{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module OGDF.SugiyamaLayout.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import OGDF.SugiyamaLayout.RawType
import OGDF.SugiyamaLayout.FFI
import OGDF.SugiyamaLayout.Interface
import OGDF.SugiyamaLayout.Cast
import OGDF.SugiyamaLayout.RawType
import OGDF.SugiyamaLayout.Cast
import OGDF.SugiyamaLayout.Interface
import OGDF.GraphAttributes.RawType
import OGDF.GraphAttributes.Cast
import OGDF.GraphAttributes.Interface
import OGDF.LayeredCrossMinModule.RawType
import OGDF.LayeredCrossMinModule.Cast
import OGDF.LayeredCrossMinModule.Interface
import OGDF.HierarchyLayoutModule.RawType
import OGDF.HierarchyLayoutModule.Cast
import OGDF.HierarchyLayoutModule.Interface
import OGDF.RankingModule.RawType
import OGDF.RankingModule.Cast
import OGDF.RankingModule.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface
import OGDF.LayoutModule.RawType
import OGDF.LayoutModule.Cast
import OGDF.LayoutModule.Interface

instance () => ISugiyamaLayout (SugiyamaLayout) where

instance () => IDeletable (SugiyamaLayout) where
        delete = xform0 c_sugiyamalayout_delete

instance () => ILayoutModule (SugiyamaLayout) where
        call = xform1 c_sugiyamalayout_call

newSugiyamaLayout :: () => IO SugiyamaLayout
newSugiyamaLayout = xformnull c_sugiyamalayout_newsugiyamalayout

sugiyamaLayout_pageRatio ::
                           () => SugiyamaLayout -> CDouble -> IO ()
sugiyamaLayout_pageRatio
  = xform1 c_sugiyamalayout_sugiyamalayout_pageratio

sugiyamaLayout_setCrossMin ::
                             (ILayeredCrossMinModule c0, FPtr c0) =>
                             SugiyamaLayout -> c0 -> IO ()
sugiyamaLayout_setCrossMin
  = xform1 c_sugiyamalayout_sugiyamalayout_setcrossmin

sugiyamaLayout_setLayout ::
                           (IHierarchyLayoutModule c0, FPtr c0) =>
                           SugiyamaLayout -> c0 -> IO ()
sugiyamaLayout_setLayout
  = xform1 c_sugiyamalayout_sugiyamalayout_setlayout

sugiyamaLayout_setRanking ::
                            (IRankingModule c0, FPtr c0) => SugiyamaLayout -> c0 -> IO ()
sugiyamaLayout_setRanking
  = xform1 c_sugiyamalayout_sugiyamalayout_setranking
